Loading...
Searching...
No Matches
Gudhi::witness_complex::SimplicialComplexForWitness Struct Reference

The concept SimplicialComplexForWitness describes the requirements for a type to implement a simplicial complex, used for example to build a Witness_complex or Strong_witness_complex. More...

`#include <concept/Witness_complex/SimplicialComplexForWitness.h>`

## Public Types

typedef unspecified | Simplex_handle
typedef unspecified | Insertion_result_type
| Return type of an insertion of a simplex.

## Public Member Functions

Simplex_handle | null_simplex ()
| Returns a Simplex_hanlde that is different from all simplex handles of the simplices.
std::size_t | num_vertices ()
template<typedef Input_vertex_range>
Insertion_result_type | insert_simplex (Input_vertex_range const &vertex_range, Filtration_value filtration)
| Inserts a simplex with vertices from a given range 'vertex_range' in the simplicial complex. The function is only used in Witness_complex class and by construction, it is not necessary to check if the faces are in the simplicial complex before insertion. The simplex is given the filtration value 'filtration'. Filtration_value should be convertible from double. The return type is not used.
template<typedef Input_vertex_range, typedef Filtration_value>
Insertion_result_type | insert_simplex_and_subfaces (Input_vertex_range const &vertex_range, Filtration_value filtration)
| Inserts a simplex and all its faces with vertices from a given range 'vertex_range' in the simplicial complex. The function is only used in Strong_witness_complex class. All inserted simplices are given the filtration value 'filtration'. Filtration_value should be convertible from double. The return type is not used.
template<typedef Input_vertex_range>
Simplex_handle | find (Input_vertex_range const &vertex_range)
| Finds a simplex with vertices given by a range.
void | set_dimension (int dimension)
| Sets the dimension of the simplicial complex to 'dimension'.
double | filtration (Simplex_handle sh)
| Returns the filtration of the simplex given by the simplex handle 'sh'.

## Detailed Description

The concept SimplicialComplexForWitness describes the requirements for a type to implement a simplicial complex, used for example to build a Witness_complex or Strong_witness_complex.

## Member Typedef Documentation

## Simplex_handle

typedef unspecified Gudhi::witness_complex::SimplicialComplexForWitness::Simplex_handle

Handle to specify a simplex.

## Member Function Documentation

## find()

template<typedef Input_vertex_range>

Simplex_handle Gudhi::witness_complex::SimplicialComplexForWitness::find | ( | Input_vertex_range const & | vertex_range | ) |

Finds a simplex with vertices given by a range.

If a simplex exists, its Simplex_handle is returned. Otherwise null_simplex() is returned.

## null_simplex()

Simplex_handle Gudhi::witness_complex::SimplicialComplexForWitness::null_simplex | ( |  | ) |

Returns a Simplex_hanlde that is different from all simplex handles of the simplices.

Handle to specify a vertex. Must be a non-negative integer.

## num_vertices()

std::size_t Gudhi::witness_complex::SimplicialComplexForWitness::num_vertices | ( |  | ) |

Returns the number of vertices in the simplicial complex

The documentation for this struct was generated from the following file:

- concept/Witness_complex/SimplicialComplexForWitness.h